JUCE: HeapBlock< ElementType, throwOnFailure > Class Template Reference

JUCE

Public Types | Public Member Functions | List of all members
HeapBlock< ElementType, throwOnFailure > Class Template Reference
juce_core » memory

Very simple container class to hold a pointer to some data on the heap. More...

`#include <juce_HeapBlock.h>`

## Public Types
using | Type = ElementType
| This typedef can be used to get the type of the heapblock's elements. More...

## Public Member Functions
| HeapBlock ()=default
| Creates a HeapBlock which is initially just a null pointer. More...
template<typename SizeType , std::enable_if_t< std::is_convertible< SizeType, int >::value, int > = 0>
| HeapBlock (SizeType numElements)
| Creates a HeapBlock containing a number of elements. More...
template<typename SizeType , std::enable_if_t< std::is_convertible< SizeType, int >::value, int > = 0>
| HeapBlock (SizeType numElements, bool initialiseToZero)
| Creates a HeapBlock containing a number of elements. More...
| ~HeapBlock ()
| Destructor. More...
| HeapBlock (HeapBlock &&other) noexcept
| Move constructor. More...
HeapBlock & | operator= (HeapBlock &&other) noexcept
| Move assignment operator. More...
template<class OtherElementType , bool otherThrowOnFailure, typename = AllowConversion<OtherElementType>>
| HeapBlock (HeapBlock< OtherElementType, otherThrowOnFailure > &&other) noexcept
| Converting move constructor. More...
template<class OtherElementType , bool otherThrowOnFailure, typename = AllowConversion<OtherElementType>>
HeapBlock & | operator= (HeapBlock< OtherElementType, otherThrowOnFailure > &&other) noexcept
| Converting move assignment operator. More...
| operator ElementType * () const noexcept
| Returns a raw pointer to the allocated data. More...
ElementType * | get () const noexcept
| Returns a raw pointer to the allocated data. More...
ElementType * | getData () const noexcept
| Returns a raw pointer to the allocated data. More...
| operator void * () const noexcept
| Returns a void pointer to the allocated data. More...
| operator const void * () const noexcept
| Returns a void pointer to the allocated data. More...
ElementType * | operator-> () const noexcept
| Lets you use indirect calls to the first element in the array. More...
template<typename IndexType >
ElementType & | operator[] (IndexType index) const noexcept
| Returns a reference to one of the data elements. More...
template<typename IndexType >
ElementType * | operator+ (IndexType index) const noexcept
| Returns a pointer to a data element at an offset from the start of the array. More...
bool | operator== (const ElementType *otherPointer) const noexcept
| Compares the pointer with another pointer. More...
bool | operator!= (const ElementType *otherPointer) const noexcept
| Compares the pointer with another pointer. More...
template<typename SizeType >
void | malloc (SizeType newNumElements, size_t elementSize=sizeof(ElementType))
| Allocates a specified amount of memory. More...
template<typename SizeType >
void | calloc (SizeType newNumElements, const size_t elementSize=sizeof(ElementType))
| Allocates a specified amount of memory and clears it. More...
template<typename SizeType >
void | allocate (SizeType newNumElements, bool initialiseToZero)
| Allocates a specified amount of memory and optionally clears it. More...
template<typename SizeType >
void | realloc (SizeType newNumElements, size_t elementSize=sizeof(ElementType))
| Re-allocates a specified amount of memory. More...
void | free () noexcept
| Frees any currently-allocated data. More...
template<bool otherBlockThrows>
void | swapWith (HeapBlock< ElementType, otherBlockThrows > &other) noexcept
| Swaps this object's data with the data of another HeapBlock. More...
template<typename SizeType >
void | clear (SizeType numElements) noexcept
| This fills the block with zeros, up to the number of elements specified. More...

## Detailed Description

template<class ElementType, bool throwOnFailure = false>
class HeapBlock< ElementType, throwOnFailure >

Very simple container class to hold a pointer to some data on the heap.

When you need to allocate some heap storage for something, always try to use this class instead of allocating the memory directly using malloc/free.

A HeapBlock<char> object can be treated in pretty much exactly the same way as an char*, but as long as you allocate it on the stack or as a class member, it's almost impossible for it to leak memory.

It also makes your code much more concise and readable than doing the same thing using direct allocations,

E.g. instead of this:

int* temp = (int*) malloc (1024 * sizeof (int));
memcpy (temp, xyz, 1024 * sizeof (int));
free (temp);
temp = (int*) calloc (2048 * sizeof (int));
temp[0] = 1234;
memcpy (foobar, temp, 2048 * sizeof (int));
free (temp);
HeapBlock::malloc
void malloc(SizeType newNumElements, size_t elementSize=sizeof(ElementType))
Allocates a specified amount of memory.
Definition: juce_HeapBlock.h:253
HeapBlock::free
void free() noexcept
Frees any currently-allocated data.
Definition: juce_HeapBlock.h:301
HeapBlock::calloc
void calloc(SizeType newNumElements, const size_t elementSize=sizeof(ElementType))
Allocates a specified amount of memory and clears it.
Definition: juce_HeapBlock.h:264

..you could just write this:

HeapBlock<int> temp (1024);
memcpy (temp, xyz, 1024 * sizeof (int));
temp.calloc (2048);
temp[0] = 1234;
memcpy (foobar, temp, 2048 * sizeof (int));
HeapBlock< int >

The class is extremely lightweight, containing only a pointer to the data, and exposes malloc/realloc/calloc/free methods that do the same jobs as their less object-oriented counterparts. Despite adding safety, you probably won't sacrifice any performance by using this in place of normal pointers.

The throwOnFailure template parameter can be set to true if you'd like the class to throw a std::bad_alloc exception when an allocation fails. If this is false, then a failed allocation will just leave the heapblock with a null pointer (assuming that the system's malloc() function doesn't throw).

See also
  Array, OwnedArray, MemoryBlock

## Member Typedef Documentation

## ◆ Type

template<class ElementType , bool throwOnFailure = false>

using HeapBlock< ElementType, throwOnFailure >::Type = ElementType

This typedef can be used to get the type of the heapblock's elements.

## Constructor & Destructor Documentation

## ◆ HeapBlock() [1/5]

template<class ElementType , bool throwOnFailure = false>

HeapBlock< ElementType, throwOnFailure >::HeapBlock | ( |  | ) |
| default

Creates a HeapBlock which is initially just a null pointer.

After creation, you can resize the array using the malloc(), calloc(), or realloc() methods.

## ◆ HeapBlock() [2/5]

template<class ElementType , bool throwOnFailure = false>
template<typename SizeType , std::enable_if_t< std::is_convertible< SizeType, int >::value, int > = 0>

HeapBlock< ElementType, throwOnFailure >::HeapBlock | ( | SizeType | numElements | ) |
| explicit

Creates a HeapBlock containing a number of elements.

The contents of the block are undefined, as it will have been created by a malloc call.

If you want an array of zero values, you can use the calloc() method or the other constructor that takes an InitialisationState parameter.

## ◆ HeapBlock() [3/5]

template<class ElementType , bool throwOnFailure = false>
template<typename SizeType , std::enable_if_t< std::is_convertible< SizeType, int >::value, int > = 0>

HeapBlock< ElementType, throwOnFailure >::HeapBlock | ( | SizeType | numElements,
|  | bool | initialiseToZero
| ) |  |

Creates a HeapBlock containing a number of elements.

The initialiseToZero parameter determines whether the new memory should be cleared, or left uninitialised.

## ◆ ~HeapBlock()

template<class ElementType , bool throwOnFailure = false>

HeapBlock< ElementType, throwOnFailure >::~HeapBlock | ( |  | ) |

Destructor.

This will free the data, if any has been allocated.

## ◆ HeapBlock() [4/5]

template<class ElementType , bool throwOnFailure = false>

HeapBlock< ElementType, throwOnFailure >::HeapBlock | ( | HeapBlock< ElementType, throwOnFailure > && | other | ) |
| noexcept

Move constructor.

## ◆ HeapBlock() [5/5]

template<class ElementType , bool throwOnFailure = false>
template<class OtherElementType , bool otherThrowOnFailure, typename = AllowConversion<OtherElementType>>

HeapBlock< ElementType, throwOnFailure >::HeapBlock | ( | HeapBlock< OtherElementType, otherThrowOnFailure > && | other | ) |
| noexcept

Converting move constructor.

Only enabled if this is a HeapBlock<Base*> and the other object is a HeapBlock<Derived*>, where std::is_base_of<Base, Derived>::value == true.

## Member Function Documentation

## ◆ operator=() [1/2]

template<class ElementType , bool throwOnFailure = false>

HeapBlock & HeapBlock< ElementType, throwOnFailure >::operator= | ( | HeapBlock< ElementType, throwOnFailure > && | other | ) |
| noexcept

Move assignment operator.

## ◆ operator=() [2/2]

template<class ElementType , bool throwOnFailure = false>
template<class OtherElementType , bool otherThrowOnFailure, typename = AllowConversion<OtherElementType>>

HeapBlock & HeapBlock< ElementType, throwOnFailure >::operator= | ( | HeapBlock< OtherElementType, otherThrowOnFailure > && | other | ) |
| noexcept

Converting move assignment operator.

Only enabled if this is a HeapBlock<Base*> and the other object is a HeapBlock<Derived*>, where std::is_base_of<Base, Derived>::value == true.

References HeapBlock< ElementType, throwOnFailure >::free().

## ◆ operator ElementType *()

template<class ElementType , bool throwOnFailure = false>

HeapBlock< ElementType, throwOnFailure >::operator ElementType * | ( |  | ) | const
| noexcept

Returns a raw pointer to the allocated data.

This may be a null pointer if the data hasn't yet been allocated, or if it has been freed by calling the free() method.

## ◆ get()

template<class ElementType , bool throwOnFailure = false>

ElementType * HeapBlock< ElementType, throwOnFailure >::get | ( |  | ) | const
| noexcept

Returns a raw pointer to the allocated data.

This may be a null pointer if the data hasn't yet been allocated, or if it has been freed by calling the free() method.

Referenced by SpeakerMappings::VstSpeakerConfigurationHolder::get(), and AudioBuffer< Type >::setSize().

## ◆ getData()

template<class ElementType , bool throwOnFailure = false>

ElementType * HeapBlock< ElementType, throwOnFailure >::getData | ( |  | ) | const
| noexcept

Returns a raw pointer to the allocated data.

This may be a null pointer if the data hasn't yet been allocated, or if it has been freed by calling the free() method.

Referenced by dsp::FIR::Filter< SampleType >::reset().

## ◆ operator void *()

template<class ElementType , bool throwOnFailure = false>

HeapBlock< ElementType, throwOnFailure >::operator void * | ( |  | ) | const
| noexcept

Returns a void pointer to the allocated data.

This may be a null pointer if the data hasn't yet been allocated, or if it has been freed by calling the free() method.

## ◆ operator const void *()

template<class ElementType , bool throwOnFailure = false>

HeapBlock< ElementType, throwOnFailure >::operator const void * | ( |  | ) | const
| noexcept

Returns a void pointer to the allocated data.

This may be a null pointer if the data hasn't yet been allocated, or if it has been freed by calling the free() method.

## ◆ operator->()

template<class ElementType , bool throwOnFailure = false>

ElementType * HeapBlock< ElementType, throwOnFailure >::operator-> | ( |  | ) | const
| noexcept

Lets you use indirect calls to the first element in the array.

Obviously this will cause problems if the array hasn't been initialised, because it'll be referencing a null pointer.

## ◆ operator[]()

template<class ElementType , bool throwOnFailure = false>
template<typename IndexType >

ElementType & HeapBlock< ElementType, throwOnFailure >::operator[] | ( | IndexType | index | ) | const
| noexcept

Returns a reference to one of the data elements.

Obviously there's no bounds-checking here, as this object is just a dumb pointer and has no idea of the size it currently has allocated.

References gl::index.

## ◆ operator+()

template<class ElementType , bool throwOnFailure = false>
template<typename IndexType >

ElementType * HeapBlock< ElementType, throwOnFailure >::operator+ | ( | IndexType | index | ) | const
| noexcept

Returns a pointer to a data element at an offset from the start of the array.

This is the same as doing pointer arithmetic on the raw pointer itself.

References gl::index.

## ◆ operator==()

template<class ElementType , bool throwOnFailure = false>

bool HeapBlock< ElementType, throwOnFailure >::operator== | ( | const ElementType * | otherPointer | ) | const
| noexcept

Compares the pointer with another pointer.

This can be handy for checking whether this is a null pointer.

## ◆ operator!=()

template<class ElementType , bool throwOnFailure = false>

bool HeapBlock< ElementType, throwOnFailure >::operator!= | ( | const ElementType * | otherPointer | ) | const
| noexcept

Compares the pointer with another pointer.

This can be handy for checking whether this is a null pointer.

## ◆ malloc()

template<class ElementType , bool throwOnFailure = false>
template<typename SizeType >

void HeapBlock< ElementType, throwOnFailure >::malloc | ( | SizeType | newNumElements,
|  | size_t | elementSize = `sizeof (ElementType)`
| ) |  |

Allocates a specified amount of memory.

This uses the normal malloc to allocate an amount of memory for this object. Any previously allocated memory will be freed by this method.

The number of bytes allocated will be (newNumElements * elementSize). Normally you wouldn't need to specify the second parameter, but it can be handy if you need to allocate a size in bytes rather than in terms of the number of elements.

The data that is allocated will be freed when this object is deleted, or when you call free() or any of the allocation methods.

Referenced by dsp::FIR::Filter< SampleType >::reset().

## ◆ calloc()

template<class ElementType , bool throwOnFailure = false>
template<typename SizeType >

void HeapBlock< ElementType, throwOnFailure >::calloc | ( | SizeType | newNumElements,
|  | const size_t | elementSize = `sizeof (ElementType)`
| ) |  |

Allocates a specified amount of memory and clears it.

This does the same job as the malloc() method, but clears the memory that it allocates.

## ◆ allocate()

template<class ElementType , bool throwOnFailure = false>
template<typename SizeType >

void HeapBlock< ElementType, throwOnFailure >::allocate | ( | SizeType | newNumElements,
|  | bool | initialiseToZero
| ) |  |

Allocates a specified amount of memory and optionally clears it.

This does the same job as either malloc() or calloc(), depending on the initialiseToZero parameter.

Referenced by AudioBuffer< Type >::setSize().

## ◆ realloc()

template<class ElementType , bool throwOnFailure = false>
template<typename SizeType >

void HeapBlock< ElementType, throwOnFailure >::realloc | ( | SizeType | newNumElements,
|  | size_t | elementSize = `sizeof (ElementType)`
| ) |  |

Re-allocates a specified amount of memory.

The semantics of this method are the same as malloc() and calloc(), but it uses realloc() to keep as much of the existing data as possible.

## ◆ free()

template<class ElementType , bool throwOnFailure = false>

void HeapBlock< ElementType, throwOnFailure >::free | ( |  | ) |
| noexcept

Frees any currently-allocated data.

This will free the data and reset this object to be a null pointer.

Referenced by HeapBlock< ElementType, throwOnFailure >::operator=(), and AudioBuffer< Type >::setDataToReferTo().

## ◆ swapWith()

template<class ElementType , bool throwOnFailure = false>
template<bool otherBlockThrows>

void HeapBlock< ElementType, throwOnFailure >::swapWith | ( | HeapBlock< ElementType, otherBlockThrows > & | other | ) |
| noexcept

Swaps this object's data with the data of another HeapBlock.

The two objects simply exchange their data pointers.

Referenced by AudioBuffer< Type >::setSize().

## ◆ clear()

template<class ElementType , bool throwOnFailure = false>
template<typename SizeType >

void HeapBlock< ElementType, throwOnFailure >::clear | ( | SizeType | numElements | ) |
| noexcept

This fills the block with zeros, up to the number of elements specified.

Since the block has no way of knowing its own size, you must make sure that the number of elements you specify doesn't exceed the allocated size.

References zeromem().

Referenced by AudioBuffer< Type >::setSize().

The documentation for this class was generated from the following file:

- juce_HeapBlock.h